import React from 'react'
import { useDrag, useDrop } from 'react-dnd'
import { Icon } from 'antd'
import './index.scss'

const Card = ({ id, card, moveCard, findCard, editCard, delCard }) => {
  const originalIndex = findCard(id).index

  const [{ isDragging }, drag] = useDrag({
    item: { type: 'chart', id, originalIndex },
    collect: monitor => ({
      isDragging: monitor.isDragging(),
    }),
  })

  const opacity = isDragging ? 0 : 1

  const edit = () => {
    editCard(id)
  }
  
  const del = () => {
    delCard(id)
  }

  const [, drop] = useDrop({
    accept: 'chart',
    canDrop: () => true,
    hover({ id: draggedId }) {
      if (!draggedId) return
      if (draggedId !== id) {
        const { index: overIndex } = findCard(id)
        moveCard(draggedId, overIndex)
      }
    }
  })

  return (
    <div className="chart-tab" style={{ opacity: opacity}}>
      <div ref={node => drag(drop(node))}>
        <Icon type={card.icon} />
      </div>
      <Icon className="edit" title="编辑" type="edit" onClick={edit} />
      {card.chartType !== 'table' ? <Icon className="edit close" title="删除" type="close" onClick={del} /> : null}
    </div>
  )
}
export default Card
